var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// node_modules/obliterator/support.js
var require_support = __commonJS({
  "node_modules/obliterator/support.js"(exports) {
    exports.ARRAY_BUFFER_SUPPORT = typeof ArrayBuffer !== "undefined";
    exports.SYMBOL_SUPPORT = typeof Symbol !== "undefined";
  }
});

// node_modules/obliterator/foreach.js
var require_foreach = __commonJS({
  "node_modules/obliterator/foreach.js"(exports, module) {
    var support = require_support();
    var ARRAY_BUFFER_SUPPORT = support.ARRAY_BUFFER_SUPPORT;
    var SYMBOL_SUPPORT = support.SYMBOL_SUPPORT;
    module.exports = function forEach(iterable, callback) {
      var iterator, k, i, l, s;
      if (!iterable)
        throw new Error("obliterator/forEach: invalid iterable.");
      if (typeof callback !== "function")
        throw new Error("obliterator/forEach: expecting a callback.");
      if (Array.isArray(iterable) || ARRAY_BUFFER_SUPPORT && ArrayBuffer.isView(iterable) || typeof iterable === "string" || iterable.toString() === "[object Arguments]") {
        for (i = 0, l = iterable.length; i < l; i++)
          callback(iterable[i], i);
        return;
      }
      if (typeof iterable.forEach === "function") {
        iterable.forEach(callback);
        return;
      }
      if (SYMBOL_SUPPORT && Symbol.iterator in iterable && typeof iterable.next !== "function") {
        iterable = iterable[Symbol.iterator]();
      }
      if (typeof iterable.next === "function") {
        iterator = iterable;
        i = 0;
        while (s = iterator.next(), s.done !== true) {
          callback(s.value, i);
          i++;
        }
        return;
      }
      for (k in iterable) {
        if (iterable.hasOwnProperty(k)) {
          callback(iterable[k], k);
        }
      }
      return;
    };
  }
});

// node_modules/mnemonist/bi-map.js
var require_bi_map = __commonJS({
  "node_modules/mnemonist/bi-map.js"(exports, module) {
    var forEach = require_foreach();
    function InverseMap(original) {
      this.size = 0;
      this.items = /* @__PURE__ */ new Map();
      this.inverse = original;
    }
    function BiMap3() {
      this.size = 0;
      this.items = /* @__PURE__ */ new Map();
      this.inverse = new InverseMap(this);
    }
    function clear() {
      this.size = 0;
      this.items.clear();
      this.inverse.items.clear();
    }
    BiMap3.prototype.clear = clear;
    InverseMap.prototype.clear = clear;
    function set(key, value) {
      if (this.items.has(key)) {
        var currentValue = this.items.get(key);
        if (currentValue === value)
          return this;
        else
          this.inverse.items.delete(currentValue);
      }
      if (this.inverse.items.has(value)) {
        var currentKey = this.inverse.items.get(value);
        if (currentKey === key)
          return this;
        else
          this.items.delete(currentKey);
      }
      this.items.set(key, value);
      this.inverse.items.set(value, key);
      this.size = this.items.size;
      this.inverse.size = this.inverse.items.size;
      return this;
    }
    BiMap3.prototype.set = set;
    InverseMap.prototype.set = set;
    function del(key) {
      if (this.items.has(key)) {
        var currentValue = this.items.get(key);
        this.items.delete(key);
        this.inverse.items.delete(currentValue);
        this.size = this.items.size;
        this.inverse.size = this.inverse.items.size;
        return true;
      }
      return false;
    }
    BiMap3.prototype.delete = del;
    InverseMap.prototype.delete = del;
    var METHODS = ["has", "get", "forEach", "keys", "values", "entries"];
    METHODS.forEach(function(name) {
      BiMap3.prototype[name] = InverseMap.prototype[name] = function() {
        return Map.prototype[name].apply(this.items, arguments);
      };
    });
    if (typeof Symbol !== "undefined") {
      BiMap3.prototype[Symbol.iterator] = BiMap3.prototype.entries;
      InverseMap.prototype[Symbol.iterator] = InverseMap.prototype.entries;
    }
    BiMap3.prototype.inspect = function() {
      var dummy = {
        left: this.items,
        right: this.inverse.items
      };
      Object.defineProperty(dummy, "constructor", {
        value: BiMap3,
        enumerable: false
      });
      return dummy;
    };
    if (typeof Symbol !== "undefined")
      BiMap3.prototype[Symbol.for("nodejs.util.inspect.custom")] = BiMap3.prototype.inspect;
    InverseMap.prototype.inspect = function() {
      var dummy = {
        left: this.inverse.items,
        right: this.items
      };
      Object.defineProperty(dummy, "constructor", {
        value: InverseMap,
        enumerable: false
      });
      return dummy;
    };
    if (typeof Symbol !== "undefined")
      InverseMap.prototype[Symbol.for("nodejs.util.inspect.custom")] = InverseMap.prototype.inspect;
    BiMap3.from = function(iterable) {
      var bimap = new BiMap3();
      forEach(iterable, function(value, key) {
        bimap.set(key, value);
      });
      return bimap;
    };
    module.exports = BiMap3;
  }
});

// node_modules/obliterator/iterator.js
var require_iterator = __commonJS({
  "node_modules/obliterator/iterator.js"(exports, module) {
    function Iterator(next) {
      if (typeof next !== "function")
        throw new Error("obliterator/iterator: expecting a function!");
      this.next = next;
    }
    if (typeof Symbol !== "undefined")
      Iterator.prototype[Symbol.iterator] = function() {
        return this;
      };
    Iterator.of = function() {
      var args = arguments, l = args.length, i = 0;
      return new Iterator(function() {
        if (i >= l)
          return { done: true };
        return { done: false, value: args[i++] };
      });
    };
    Iterator.empty = function() {
      var iterator = new Iterator(function() {
        return { done: true };
      });
      return iterator;
    };
    Iterator.fromSequence = function(sequence) {
      var i = 0, l = sequence.length;
      return new Iterator(function() {
        if (i >= l)
          return { done: true };
        return { done: false, value: sequence[i++] };
      });
    };
    Iterator.is = function(value) {
      if (value instanceof Iterator)
        return true;
      return typeof value === "object" && value !== null && typeof value.next === "function";
    };
    module.exports = Iterator;
  }
});

// node_modules/mnemonist/queue.js
var require_queue = __commonJS({
  "node_modules/mnemonist/queue.js"(exports, module) {
    var Iterator = require_iterator();
    var forEach = require_foreach();
    function Queue3() {
      this.clear();
    }
    Queue3.prototype.clear = function() {
      this.items = [];
      this.offset = 0;
      this.size = 0;
    };
    Queue3.prototype.enqueue = function(item) {
      this.items.push(item);
      return ++this.size;
    };
    Queue3.prototype.dequeue = function() {
      if (!this.size)
        return;
      var item = this.items[this.offset];
      if (++this.offset * 2 >= this.items.length) {
        this.items = this.items.slice(this.offset);
        this.offset = 0;
      }
      this.size--;
      return item;
    };
    Queue3.prototype.peek = function() {
      if (!this.size)
        return;
      return this.items[this.offset];
    };
    Queue3.prototype.forEach = function(callback, scope) {
      scope = arguments.length > 1 ? scope : this;
      for (var i = this.offset, j = 0, l = this.items.length; i < l; i++, j++)
        callback.call(scope, this.items[i], j, this);
    };
    Queue3.prototype.toArray = function() {
      return this.items.slice(this.offset);
    };
    Queue3.prototype.values = function() {
      var items = this.items, i = this.offset;
      return new Iterator(function() {
        if (i >= items.length)
          return {
            done: true
          };
        var value = items[i];
        i++;
        return {
          value,
          done: false
        };
      });
    };
    Queue3.prototype.entries = function() {
      var items = this.items, i = this.offset, j = 0;
      return new Iterator(function() {
        if (i >= items.length)
          return {
            done: true
          };
        var value = items[i];
        i++;
        return {
          value: [j++, value],
          done: false
        };
      });
    };
    if (typeof Symbol !== "undefined")
      Queue3.prototype[Symbol.iterator] = Queue3.prototype.values;
    Queue3.prototype.toString = function() {
      return this.toArray().join(",");
    };
    Queue3.prototype.toJSON = function() {
      return this.toArray();
    };
    Queue3.prototype.inspect = function() {
      var array = this.toArray();
      Object.defineProperty(array, "constructor", {
        value: Queue3,
        enumerable: false
      });
      return array;
    };
    if (typeof Symbol !== "undefined")
      Queue3.prototype[Symbol.for("nodejs.util.inspect.custom")] = Queue3.prototype.inspect;
    Queue3.from = function(iterable) {
      var queue = new Queue3();
      forEach(iterable, function(value) {
        queue.enqueue(value);
      });
      return queue;
    };
    Queue3.of = function() {
      return Queue3.from(arguments);
    };
    module.exports = Queue3;
  }
});

// src/engine/index.ts
var EngineConfig = class {
  constructor(conf) {
    this.engine = config_default.engineType;
    this.insertionPoint = config_default.insertionPoint;
    if (conf == void 0) {
      return;
    }
    this.insertionPoint = conf.insertionPoint;
    this.engine = conf.engine;
  }
  toString() {
    return JSON.stringify(this);
  }
};
var Client = class {
  constructor(client) {
    this.name = client.resourceClass;
    this.minSize = client.minSize;
  }
};
var Tile = class _Tile {
  constructor(parent) {
    this.tiles = [];
    this.layoutDirection = 1;
    // requested size in pixels, may not be honored
    this.requestedSize = null;
    this.client = null;
    this.parent = parent ?? null;
    if (!this.parent) {
      return;
    }
    this.parent.tiles.push(this);
  }
  // adds a child that will split perpendicularly to the parent. Returns the child
  addChild() {
    let splitDirection = 1;
    if (this.layoutDirection == 1) {
      splitDirection = 2;
    }
    const childTile = new _Tile(this);
    childTile.layoutDirection = splitDirection;
    return childTile;
  }
  // adds a child that will split parallel to the parent. Not really recommeneded
  addChildParallel() {
    const childTile = new _Tile(this);
    childTile.layoutDirection = this.layoutDirection;
    return childTile;
  }
  // split a tile perpendicularly
  split() {
    this.addChild();
    this.addChild();
  }
  // have a tile replace its parent, destroying its siblings
  secede() {
    const parent = this.parent;
    if (parent == null) {
      return;
    }
    this.parent = parent.parent;
    if (this.parent != null) {
      this.parent.tiles[this.parent.tiles.indexOf(parent)] = this;
      for (const tile of parent.tiles) {
        if (tile != this) {
          tile.remove(true);
        }
      }
      parent.tiles = [];
      parent.client = null;
    } else {
      parent.client = this.client;
      parent.tiles = this.tiles;
      this.tiles = [];
      this.client = null;
    }
  }
  // removes a tile and all its children
  remove(batchRemove = false) {
    const parent = this.parent;
    if (parent == null) {
      return;
    }
    if (!batchRemove) {
      parent.tiles.splice(parent.tiles.indexOf(this), 1);
    }
    this.tiles = [];
    this.client = null;
  }
  // remove child tiles
  removeChildren() {
    for (const tile of this.tiles) {
      tile.remove(true);
    }
    this.tiles = [];
  }
};
var RootTile = class extends Tile {
  constructor(layoutDirection) {
    super();
    this.parent = null;
    this.layoutDirection = layoutDirection;
  }
};
var TilingEngine = class {
  constructor(config) {
    this.rootTile = new RootTile(1);
    this.config = new EngineConfig(config);
  }
};

// src/util/geometry.ts
var GSize = class _GSize {
  constructor(s) {
    this.width = 0;
    this.height = 0;
    if (s == void 0) {
      return;
    }
    this.width = s.width;
    this.height = s.height;
  }
  static fromRect(r) {
    return new _GSize(
      {
        "width": r.width,
        "height": r.height
      }
    );
  }
  // compare two sizes and grow the caller if it is too small
  fitSize(s) {
    if (this.height < s.height) {
      this.height = s.height;
    }
    if (this.width < s.width) {
      this.width = s.width;
    }
  }
  write(s) {
    if (s.width != this.width) {
      s.width = this.width;
    }
    if (s.height != this.height) {
      s.height = this.height;
    }
  }
};

// src/engine/layouts/btree.ts
var import_bi_map = __toESM(require_bi_map());
var import_queue = __toESM(require_queue());
var TreeNode = class _TreeNode {
  constructor() {
    this.parent = null;
    this.sibling = null;
    this.children = null;
    this.client = null;
    this.requestedSize = null;
  }
  // splits tile
  split() {
    if (this.children != null)
      return;
    this.children = [new _TreeNode(), new _TreeNode()];
    this.children[0].parent = this;
    this.children[0].sibling = this.children[1];
    this.children[1].parent = this;
    this.children[1].sibling = this.children[0];
  }
  // removes self
  remove() {
    if (this.children != null || this.sibling == null || this.parent == null)
      return;
    if (this.sibling.children != null) {
      this.parent.children = this.sibling.children;
      for (const child of this.parent.children) {
        child.parent = this.parent;
      }
    } else {
      this.parent.client = this.sibling.client;
      this.parent.children = null;
    }
    this.parent = null;
    this.sibling.parent = null;
    this.sibling.sibling = null;
    this.sibling = null;
  }
};
var RootNode = class extends TreeNode {
  constructor() {
    super(...arguments);
    this.parent = null;
    this.sibling = null;
  }
  remove() {
    this.children = null;
    this.client = null;
  }
};
var BTreeEngine = class extends TilingEngine {
  constructor() {
    super(...arguments);
    this.rootNode = new RootNode();
    this.nodeMap = new import_bi_map.default();
  }
  buildLayout() {
    this.rootTile = new RootTile(1);
    this.nodeMap = new import_bi_map.default();
    let queue = new import_queue.default();
    queue.enqueue(this.rootNode);
    this.nodeMap.set(this.rootNode, this.rootTile);
    while (queue.size > 0) {
      const node = queue.dequeue();
      const tile = this.nodeMap.get(node);
      tile.requestedSize = node.requestedSize;
      if (node.client != null) {
        tile.client = node.client;
      }
      if (node.children != null) {
        tile.split();
        this.nodeMap.set(node.children[0], tile.tiles[0]);
        this.nodeMap.set(node.children[1], tile.tiles[1]);
        queue.enqueue(node.children[0]);
        queue.enqueue(node.children[1]);
      }
    }
  }
  addClient(client) {
    let queue = new import_queue.default();
    queue.enqueue(this.rootNode);
    while (queue.size > 0) {
      const node = queue.dequeue();
      if (node.children == null) {
        if (node.client != null) {
          node.split();
          if (this.config.insertionPoint == 0 /* Left */) {
            node.children[0].client = client;
            node.children[1].client = node.client;
          } else {
            node.children[0].client = node.client;
            node.children[1].client = client;
          }
          node.client = null;
        } else {
          node.client = client;
        }
        return;
      } else {
        const children = Array.from(node.children);
        if (this.config.insertionPoint == 1 /* Right */) {
          children.reverse();
        }
        for (const child of children) {
          queue.enqueue(child);
        }
      }
    }
  }
  removeClient(client) {
    let queue = new import_queue.default();
    queue.enqueue(this.rootNode);
    let deleteQueue = [];
    while (queue.size > 0) {
      const node = queue.dequeue();
      if (node.client == client) {
        deleteQueue.push(node);
      }
      if (node.children != null) {
        for (const child of node.children) {
          queue.enqueue(child);
        }
      }
    }
    for (const node of deleteQueue) {
      node.remove();
    }
  }
  putClientInTile(client, tile, _direction) {
    const node = this.nodeMap.inverse.get(tile);
    if (node == void 0) {
      throw new Error("Node not found for tile");
    }
    if (node.client == null) {
      node.client = client;
    } else {
      node.split();
      node.children[0].client = node.client;
      node.children[1].client = client;
      node.client = null;
    }
  }
  regenerateLayout() {
    for (const node of this.nodeMap.keys()) {
      const tile = this.nodeMap.get(node);
      node.requestedSize = new GSize(tile.requestedSize);
    }
  }
};

// src/engine/layouts/half.ts
var ClientBox = class {
  constructor(client) {
    this.size = null;
    this.client = client;
  }
};
var BoxIndex = class {
  constructor(engine, client) {
    this.left = false;
    this.right = false;
    for (let i = 0; i < engine.left.length; i += 1) {
      if (engine.left[i].client == client) {
        this.index = i;
        this.left = true;
        this.box = engine.left[i];
        return;
      }
    }
    for (let i = 0; i < engine.right.length; i += 1) {
      if (engine.right[i].client == client) {
        this.index = i;
        this.right = true;
        this.box = engine.right[i];
        return;
      }
    }
    throw new Error("Couldn't find box");
  }
};
var HalfEngine = class extends TilingEngine {
  constructor() {
    super(...arguments);
    this.tileMap = /* @__PURE__ */ new Map();
    this.left = [];
    this.right = [];
  }
  buildLayout() {
    this.rootTile = new RootTile(1);
    if (this.left.length == 0 && this.right.length == 0) {
      return;
    } else if (this.left.length == 0 && this.right.length > 0) {
      for (const box of this.right) {
        const tile = this.rootTile.addChild();
        tile.client = box.client;
        tile.requestedSize = box.size;
        this.tileMap.set(tile, box);
      }
    } else if (this.left.length > 0 && this.right.length == 0) {
      for (const box of this.left) {
        const tile = this.rootTile.addChild();
        tile.client = box.client;
        tile.requestedSize = box.size;
        this.tileMap.set(tile, box);
      }
    } else {
      this.rootTile.split();
      const left = this.rootTile.tiles[0];
      const right = this.rootTile.tiles[1];
      for (const box of this.left) {
        const tile = left.addChild();
        tile.client = box.client;
        tile.requestedSize = box.size;
        this.tileMap.set(tile, box);
      }
      for (const box of this.right) {
        const tile = right.addChild();
        tile.client = box.client;
        tile.requestedSize = box.size;
        this.tileMap.set(tile, box);
      }
    }
  }
  addClient(client) {
    if (this.config.insertionPoint == 0 /* Left */) {
      if (this.right.length == 0) {
        this.right.push(new ClientBox(client));
      } else {
        this.left.push(new ClientBox(client));
      }
    } else {
      if (this.left.length == 0) {
        this.left.push(new ClientBox(client));
      } else {
        this.right.push(new ClientBox(client));
      }
    }
  }
  removeClient(client) {
    let box;
    try {
      box = new BoxIndex(this, client);
    } catch (e) {
      throw e;
    }
    if (box.right) {
      this.right.splice(box.index, 1);
      if (this.right.length == 0 && this.left.length != 0) {
        this.right.push(this.left.splice(0, 1)[0]);
      }
    } else {
      this.left.splice(box.index, 1);
      if (this.left.length == 0 && this.right.length != 0) {
        this.left.push(this.right.splice(0, 1)[0]);
      }
    }
  }
  putClientInTile(client, tile, _direction) {
    const clientBox = new ClientBox(client);
    let targetBox;
    try {
      const box = this.tileMap.get(tile);
      if (box == void 0) {
        throw new Error("Box not found for tile");
      }
      targetBox = new BoxIndex(this, box.client);
    } catch (e) {
      throw e;
    }
    const targetArr = targetBox.left ? this.left : this.right;
    targetArr.splice(targetBox.index, 0, clientBox);
  }
  regenerateLayout() {
    for (const tile of this.tileMap.keys()) {
      if (tile.requestedSize == null) {
        continue;
      }
      this.tileMap.get(tile).size = new GSize(tile.requestedSize);
    }
  }
};

// src/engine/factory.ts
var TilingEngineFactory = class {
  newEngine(t, config) {
    t %= 2 /* _loop */;
    switch (t) {
      case 0 /* BTree */:
        return new BTreeEngine(config);
      case 1 /* Half */:
        return new HalfEngine(config);
      default:
        log_default.error("Engine not found for engine type", t);
        return new BTreeEngine(config);
    }
  }
};

// src/util/config.ts
var ConfigClass = class {
  constructor() {
    this.debug = false;
    this.engineType = 0 /* BTree */;
    this.insertionPoint = 0 /* Left */;
    this.timerDelay = 10;
    this.keepTiledBelow = true;
    this.borders = 1 /* NoTiled */;
  }
  init(c) {
    this.readConfigFn = c.kwinApi.readConfig;
    this.readConfig();
  }
  readConfig() {
    let rc = this.readConfigFn;
    if (rc == void 0) {
      return;
    }
    this.debug = rc("Debug", false);
    this.engineType = rc("EngineType", 0 /* BTree */);
    this.insertionPoint = rc("InsertionPoint", 0 /* Left */);
    this.timerDelay = rc("TimerDelay", 10);
    this.keepTiledBelow = rc("KeepTiledBelow", true);
    this.borders = rc("Borders", 1 /* NoTiled */);
  }
};
var Config = new ConfigClass();
var config_default = Config;
function init(c) {
  Config.init(c);
}

// src/util/log.ts
var LogClass = class {
  init(c) {
    this.printFn = c.qmlObjects.root.printQml;
  }
  print(opener, stuff) {
    if (this.printFn == void 0) {
      return;
    }
    let ret = opener;
    for (const s of stuff) {
      ret += " ";
      ret += s;
    }
    this.printFn(ret);
  }
  debug(...stuff) {
    if (!config_default.debug)
      return;
    this.print("Polonium DBG:", stuff);
  }
  info(...stuff) {
    this.print("Polonium INF:", stuff);
  }
  error(...stuff) {
    this.print("Polonium ERR:", stuff);
  }
};
var Log = new LogClass();
var log_default = Log;
function init2(c) {
  Log.init(c);
}

// src/driver/driver.ts
var import_bi_map2 = __toESM(require_bi_map());
var import_queue2 = __toESM(require_queue());
var TilingDriver = class {
  constructor(engine, engineType, manager) {
    this.tiles = new import_bi_map2.default();
    this.clients = new import_bi_map2.default();
    this.clientsToNull = [];
    this.engine = engine;
    this.engineType = engineType;
    this.manager = manager;
  }
  switchEngine(engine, engineType) {
    this.engine = engine;
    this.engineType = engineType;
    try {
      for (const client of this.clients.values()) {
        this.engine.addClient(client);
      }
      this.engine.buildLayout();
    } catch (e) {
      throw e;
    }
  }
  buildLayout(rootTile) {
    const ret = [];
    const rootTileSize = rootTile.absoluteGeometry;
    while (rootTile.tiles.length > 0) {
      rootTile.tiles[0].remove();
    }
    this.tiles.clear();
    const queue = new import_queue2.default();
    queue.enqueue(this.engine.rootTile);
    this.tiles.set(rootTile, this.engine.rootTile);
    for (const client of this.clientsToNull) {
      client.tile = null;
    }
    this.clientsToNull = [];
    while (queue.size > 0) {
      const tile = queue.dequeue();
      const kwinTile = this.tiles.inverse.get(tile);
      kwinTile.managed = true;
      kwinTile.layoutDirection = tile.layoutDirection;
      const horizontal = kwinTile.layoutDirection == 1;
      const tilesLen = tile.tiles.length;
      if (tilesLen > 1) {
        for (let i = 0; i < tilesLen; i += 1) {
          if (i == 0) {
            kwinTile.split(tile.layoutDirection);
          } else if (i > 1) {
            kwinTile.tiles[i - 1].split(tile.layoutDirection);
          }
          if (horizontal && i > 0) {
            kwinTile.tiles[i - 1].relativeGeometry.width = kwinTile.relativeGeometry.width / tilesLen;
          } else if (i > 0) {
            kwinTile.tiles[i - 1].relativeGeometry.height = kwinTile.relativeGeometry.height / tilesLen;
          }
          this.tiles.set(kwinTile.tiles[i], tile.tiles[i]);
          queue.enqueue(tile.tiles[i]);
        }
      } else if (tilesLen == 1) {
        this.tiles.set(kwinTile, tile.tiles[0]);
        queue.enqueue(tile.tiles[0]);
      }
      const tileSize = new GSize(kwinTile.absoluteGeometry);
      if (tile.requestedSize != null) {
        tileSize.fitSize(tile.requestedSize);
      }
      if (tile.client != null) {
        const kwinClient = this.clients.inverse.get(tile.client);
        if (kwinClient == void 0) {
          log_default.error("Client", tile.client.name, "does not exist");
          return ret;
        }
        tileSize.fitSize(kwinClient.minSize);
        ret.push([kwinClient, kwinTile]);
        kwinClient.tile = kwinTile;
      }
      tileSize.height /= rootTileSize.height;
      tileSize.width /= rootTileSize.width;
      tileSize.write(kwinTile.relativeGeometry);
    }
    return ret;
  }
  addClient(kwinClient) {
    if (this.clients.has(kwinClient)) {
      return;
    }
    const client = new Client(kwinClient);
    this.clients.set(kwinClient, client);
    let failedActive = true;
    activeChecks:
      if (this.engine.config.insertionPoint == 2 /* Active */) {
        failedActive = false;
        const activeClient = this.manager.ctrl.workspace.activeClient;
        if (activeClient == null || activeClient.tile == null) {
          failedActive = true;
          break activeChecks;
        }
        const tile = this.tiles.get(activeClient.tile);
        if (tile == void 0) {
          failedActive = true;
          break activeChecks;
        }
        this.engine.putClientInTile(client, tile);
      }
    try {
      if (failedActive) {
        this.engine.addClient(client);
      }
      this.engine.buildLayout();
    } catch (e) {
      log_default.error(e);
    }
  }
  removeClient(kwinClient) {
    const client = this.clients.get(kwinClient);
    if (client == void 0) {
      return;
    }
    this.clients.delete(kwinClient);
    this.clientsToNull.push(kwinClient);
    try {
      this.engine.removeClient(client);
      this.engine.buildLayout();
    } catch (e) {
      log_default.error(e);
    }
  }
  putClientInTile(kwinClient, kwinTile, direction) {
    const tile = this.tiles.get(kwinTile);
    if (tile == void 0) {
      log_default.error("Tile", kwinTile.absoluteGeometry, "not registered");
      return;
    }
    if (!this.clients.has(kwinClient)) {
      this.clients.set(kwinClient, new Client(kwinClient));
    }
    const client = this.clients.get(kwinClient);
    try {
      this.engine.putClientInTile(client, tile, direction);
      this.engine.buildLayout();
    } catch (e) {
      log_default.error(e);
    }
  }
  regenerateLayout(rootTile) {
    const queue = new import_queue2.default();
    queue.enqueue(rootTile);
    while (queue.size > 0) {
      const kwinTile = queue.dequeue();
      const tile = this.tiles.get(kwinTile);
      if (tile == void 0) {
        log_default.error("Tile", kwinTile.absoluteGeometry, "not registered");
        continue;
      }
      tile.requestedSize = GSize.fromRect(kwinTile.absoluteGeometry);
      for (const tile2 of kwinTile.tiles) {
        queue.enqueue(tile2);
      }
    }
    try {
      this.engine.regenerateLayout();
      this.engine.buildLayout();
    } catch (e) {
      log_default.error(e);
    }
  }
};

// src/driver/index.ts
var Desktop = class _Desktop {
  toString() {
    return "(" + this.screen + ", " + this.activity + ", " + this.desktop + ")";
  }
  constructor(d) {
    this.screen = d.screen;
    this.activity = d.activity;
    this.desktop = d.desktop;
  }
  static fromClient(client) {
    let ret = [];
    for (const activity of client.activities) {
      ret.push(new _Desktop({
        screen: client.screen,
        activity,
        desktop: client.desktop
      }));
    }
    return ret;
  }
  static currentScreens(c) {
    let ret = [];
    for (let i = 0; i < c.workspace.numScreens; i += 1) {
      ret.push(new _Desktop({
        screen: i,
        activity: c.workspace.currentActivity,
        desktop: c.workspace.currentDesktop
      }));
    }
    return ret;
  }
};
var DriverManager = class {
  constructor(c) {
    this.drivers = /* @__PURE__ */ new Map();
    this.engineFactory = new TilingEngineFactory();
    this.rootTileCallbacks = /* @__PURE__ */ new Map();
    this.buildingLayout = false;
    this.ctrl = c;
  }
  getDriver(desktop) {
    const desktopString = desktop.toString();
    if (!this.drivers.has(desktopString)) {
      const engineType = config_default.engineType;
      const engine = this.engineFactory.newEngine(engineType);
      const driver = new TilingDriver(engine, engineType, this);
      this.drivers.set(desktopString, driver);
    }
    return this.drivers.get(desktopString);
  }
  layoutModified(tile) {
    if (this.buildingLayout) {
      return;
    }
    const timer = this.rootTileCallbacks.get(tile);
    if (timer == void 0) {
      log_default.error("Callback not registered for root tile", tile.absoluteGeometry);
      return;
    }
    timer.restart();
  }
  layoutModifiedCallback(tile, scr) {
    log_default.debug("Layout modified for tile", tile.absoluteGeometry);
    const desktop = new Desktop(
      {
        screen: scr,
        activity: this.ctrl.workspace.currentActivity,
        desktop: this.ctrl.workspace.currentDesktop
      }
    );
    const driver = this.getDriver(desktop);
    driver.regenerateLayout(tile);
  }
  hookRootTiles() {
    for (let i = 0; i < this.ctrl.workspace.numScreens; i += 1) {
      const rootTile = this.ctrl.workspace.tilingForScreen(i).rootTile;
      if (rootTile.managed) {
        continue;
      }
      rootTile.managed = true;
      const timer = this.ctrl.qmlObjects.root.createTimer();
      timer.interval = config_default.timerDelay;
      timer.triggered.connect(this.layoutModifiedCallback.bind(this, rootTile, i));
      timer.repeat = false;
      this.rootTileCallbacks.set(rootTile, timer);
      rootTile.layoutModified.connect(this.layoutModified.bind(this, rootTile));
    }
  }
  applyTiled(client) {
    client.isTiled = true;
    if (config_default.keepTiledBelow) {
      client.keepBelow = true;
    }
    if (config_default.borders == 1 /* NoTiled */ || config_default.borders == 2 /* Selected */) {
      client.noBorder = true;
    }
  }
  rebuildLayout(scr) {
    this.buildingLayout = true;
    let desktops;
    if (scr == void 0) {
      desktops = Desktop.currentScreens(this.ctrl);
    } else {
      desktops = [new Desktop({
        screen: scr,
        activity: this.ctrl.workspace.currentActivity,
        desktop: this.ctrl.workspace.currentDesktop
      })];
    }
    for (const desktop of desktops) {
      const driver = this.getDriver(desktop);
      driver.buildLayout(this.ctrl.workspace.tilingForScreen(desktop.screen).rootTile);
    }
    this.buildingLayout = false;
  }
  addClient(client, desktops) {
    if (desktops == void 0) {
      desktops = Desktop.fromClient(client);
    }
    for (const desktop of desktops) {
      const driver = this.getDriver(desktop);
      driver.addClient(client);
    }
    this.applyTiled(client);
  }
  removeClient(client, desktops) {
    if (desktops == void 0) {
      desktops = Desktop.fromClient(client);
    }
    for (const desktop of desktops) {
      const driver = this.getDriver(desktop);
      driver.removeClient(client);
    }
    client.isTiled = false;
    if (config_default.keepTiledBelow) {
      client.keepBelow = false;
    }
    if (config_default.borders == 1 /* NoTiled */ || config_default.borders == 2 /* Selected */) {
      client.noBorder = false;
    }
  }
  putClientInTile(client, tile, direction) {
    const desktop = new Desktop(
      {
        screen: client.screen,
        activity: this.ctrl.workspace.currentActivity,
        desktop: this.ctrl.workspace.currentDesktop
      }
    );
    const driver = this.getDriver(desktop);
    driver.putClientInTile(client, tile, direction);
    this.applyTiled(client);
  }
  getEngineConfig(desktop) {
    return this.getDriver(desktop).engine.config;
  }
  setEngineConfig(config, desktop) {
    log_default.debug("Setting engine config for desktop", desktop);
    const driver = this.getDriver(desktop);
    if (config.engine != driver.engine.config.engine) {
      driver.switchEngine(this.engineFactory.newEngine(config.engine, config), config.engine);
    } else {
      driver.engine.config = new EngineConfig(config);
    }
    this.rebuildLayout(desktop.screen);
  }
};

// src/controller/actions/clienthooks.ts
function attachClientHooks(client) {
  if (client.hooksRegistered) {
    return;
  }
  client.hooksRegistered = true;
  client.previousDesktops = Desktop.fromClient(client);
  client.desktopChanged.connect(clientDesktopChanged.bind(this, client));
  client.activitiesChanged.connect(clientDesktopChanged.bind(this, client));
  client.screenChanged.connect(clientDesktopChanged.bind(this, client));
  client.tileChanged.connect(clientTileChanged.bind(this, client));
}
function clientDesktopChanged(client) {
  if (client.previousDesktops == void 0 || !client.isTiled) {
    return;
  }
  const currentDesktops = Desktop.fromClient(client);
  const removeDesktops = [];
  for (const desktop of client.previousDesktops) {
    if (!currentDesktops.includes(desktop)) {
      removeDesktops.push(desktop);
    }
  }
  this.manager.removeClient(client, removeDesktops);
  const addDesktops = [];
  for (const desktop of currentDesktops) {
    if (!client.previousDesktops.includes(desktop)) {
      addDesktops.push(desktop);
    }
  }
  this.manager.addClient(client, addDesktops);
  client.previousDesktops = currentDesktops;
  this.manager.rebuildLayout();
}
function clientTileChanged(client) {
  if (this.manager.buildingLayout)
    return;
  const timer = this.qmlObjects.root.createTimer();
  timer.triggeredOnStart = false;
  timer.repeat = false;
  timer.interval = config_default.timerDelay;
  timer.triggered.connect(clientTileChangedCallback.bind(this, client, timer));
  timer.start();
}
function clientTileChangedCallback(client, timer) {
  const inManagedTile = client.tile != null && client.tile.managed == true;
  if (!client.isTiled && inManagedTile) {
    log_default.debug("Putting client", client.resourceClass, "in tile", client.tile.absoluteGeometry);
    attachClientHooks.bind(this)(client);
    this.manager.putClientInTile(client, client.tile);
    this.manager.rebuildLayout(client.screen);
  } else if (client.isTiled && !inManagedTile && client.tile == null) {
    log_default.debug("Client", client.resourceClass, "was moved out of a tile");
    this.manager.removeClient(client);
    this.manager.rebuildLayout(client.screen);
  }
  timer.destroy();
}

// src/controller/actions/basic.ts
function doTileClient(c) {
  if (c.normalWindow) {
    return true;
  } else {
    return false;
  }
}
function clientAdded(client) {
  if (!doTileClient(client)) {
    log_default.debug("Not tiling client", client.resourceClass);
    return;
  }
  if (config_default.borders == 0 /* NoAll */) {
    client.noBorder = true;
  }
  attachClientHooks.bind(this)(client);
  log_default.debug("Tiling client", client.resourceClass);
  this.manager.addClient(client);
  this.manager.rebuildLayout();
}
function clientRemoved(client) {
  log_default.debug("Untiling client", client.resourceClass);
  this.manager.removeClient(client);
  this.manager.rebuildLayout();
}
function currentDesktopChange() {
  this.manager.buildingLayout = true;
  for (const client of Array.from(this.workspace.clientList())) {
    if (client.tile != null && client.activities.includes(this.workspace.lastActivity) && client.desktop == this.workspace.lastDesktop) {
      const tile = client.tile;
      client.tile = null;
      client.frameGeometry = tile.absoluteGeometry;
      client.frameGeometry.width -= 2 * tile.padding;
      client.frameGeometry.height -= 2 * tile.padding;
      client.frameGeometry.x += tile.padding;
      client.frameGeometry.y += tile.padding;
    }
  }
  this.workspace.lastActivity = this.workspace.currentActivity;
  this.workspace.lastDesktop = this.workspace.currentDesktop;
  this.manager.rebuildLayout();
}
function clientActivated(client) {
  if (config_default.borders == 2 /* Selected */) {
    client.noBorder = false;
    if (this.glob.lastActiveClient != null && this.glob.lastActiveClient.isTiled) {
      this.glob.lastActiveClient.noBorder = true;
    }
  }
  this.glob.lastActiveClient = client;
}

// src/controller/actions/shortcuts.ts
function retileWindow() {
  const client = this.workspace.activeClient;
  if (client == null) {
    return;
  }
  if (client.isTiled) {
    clientRemoved.bind(this)(client);
  } else {
    clientAdded.bind(this)(client);
  }
}
function openSettingsDialog() {
  this.qmlObjects.settings.setSettings(this.manager.getEngineConfig(this.currentDesktop));
  this.qmlObjects.settings.show();
}

// src/controller/actions/settingsdialog.ts
function saveSettings(settings, desktop) {
  this.manager.setEngineConfig(settings, new Desktop(desktop));
}
function removeSettings(desktop) {
  this.manager.setEngineConfig(new EngineConfig(), new Desktop(desktop));
}

// src/controller/index.ts
var ExtraGlobals = class {
  constructor(c) {
    this.lastActiveClient = c.workspace.activeClient;
  }
};
var Controller = class {
  constructor(qmlApi, qmlObjects) {
    this.manager = new DriverManager(this);
    this.workspace = qmlApi.workspace;
    this.options = qmlApi.options;
    this.kwinApi = qmlApi.kwin;
    this.qmlObjects = qmlObjects;
    this.glob = new ExtraGlobals(this);
  }
  get currentDesktop() {
    return new Desktop(
      {
        screen: this.workspace.activeScreen,
        activity: this.workspace.currentActivity,
        desktop: this.workspace.currentDesktop
      }
    );
  }
  initGlobals() {
    init(this);
    init2(this);
  }
  bindSignals() {
    this.workspace.clientAdded.connect(clientAdded.bind(this));
    this.workspace.clientRemoved.connect(clientRemoved.bind(this));
    this.workspace.currentDesktopChanged.connect(currentDesktopChange.bind(this));
    this.manager.hookRootTiles();
    this.workspace.numberScreensChanged.connect(this.manager.hookRootTiles);
    this.workspace.clientActivated.connect(clientActivated.bind(this));
    this.qmlObjects.settings.saveSettings.connect(saveSettings.bind(this));
    this.qmlObjects.settings.removeSettings.connect(removeSettings.bind(this));
  }
  bindShortcuts() {
    const rs = this.kwinApi.registerShortcut;
    rs("PoloniumRetileWindow", "Polonium: Untile/Retile Window", "Meta+Shift+Space", retileWindow.bind(this));
    rs("PoloniumOpenSettings", "Polonium: Open Settings Dialog", "Meta+|", openSettingsDialog.bind(this));
  }
  init() {
    this.initGlobals();
    log_default.debug("Globals initialized");
    log_default.debug("Config set to", JSON.stringify(config_default));
    this.bindSignals();
    log_default.debug("Signals bound");
    this.bindShortcuts();
    log_default.debug("Shortcuts bound");
  }
};

// src/index.ts
function main(api, qmlObjects) {
  const ctrl = new Controller(api, qmlObjects);
  ctrl.init();
}
export {
  main
};
